import{S as Fn,i as qn,s as Cn,e as a,k as l,w as _,t as s,M as Kn,c as n,d as t,m as d,a as r,x as b,h as i,b as c,G as e,g as m,y as v,q as y,o as w,B as x,v as Wn,L as On}from"../../chunks/vendor-hf-doc-builder.js";import{T as An}from"../../chunks/Tip-hf-doc-builder.js";import{D}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Un}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Xe}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ln}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Vn(C){let p,k,u,f,M;return f=new Un({props:{code:`import torch
import torch.nn as nn
from huggingface_hub import PyTorchModelHubMixin


class MyModel(nn.Module, PyTorchModelHubMixin):
    def __init__(self):
        super().__init__()
        self.param = nn.Parameter(torch.rand(3, 4))
        self.linear = nn.Linear(4, 5)

    def forward(self, x):
        return self.linear(x + self.param)


model = MyModel()
# Save model weights to local directory
model.save_pretrained("my-awesome-model")
# Push model weights to the Hub
model.push_to_hub("my-awesome-model")
# Download and initialize weights from the Hub
model = MyModel.from_pretrained("username/my-awesome-model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch.nn <span class="hljs-keyword">as</span> nn
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> PyTorchModelHubMixin


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">class</span> <span class="hljs-title class_">MyModel</span>(nn.Module, PyTorchModelHubMixin):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
<span class="hljs-meta">... </span>        <span class="hljs-built_in">super</span>().__init__()
<span class="hljs-meta">... </span>        self.param = nn.Parameter(torch.rand(<span class="hljs-number">3</span>, <span class="hljs-number">4</span>))
<span class="hljs-meta">... </span>        self.linear = nn.Linear(<span class="hljs-number">4</span>, <span class="hljs-number">5</span>)

<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, x</span>):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">return</span> self.linear(x + self.param)


<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save model weights to local directory</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Push model weights to the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download and initialize weights from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel.from_pretrained(<span class="hljs-string">&quot;username/my-awesome-model&quot;</span>)`}}),{c(){p=a("p"),k=s("Example:"),u=l(),_(f.$$.fragment)},l(g){p=n(g,"P",{});var $=r(p);k=i($,"Example:"),$.forEach(t),u=d(g),b(f.$$.fragment,g)},m(g,$){m(g,p,$),e(p,k),m(g,u,$),v(f,g,$),M=!0},p:On,i(g){M||(y(f.$$.fragment,g),M=!0)},o(g){w(f.$$.fragment,g),M=!1},d(g){g&&t(p),g&&t(u),x(f,g)}}}function Rn(C){let p,k;return p=new Un({props:{code:`import tensorflow as tf
from huggingface_hub import KerasModelHubMixin


class MyModel(tf.keras.Model, KerasModelHubMixin):
    def __init__(self, **kwargs):
        super().__init__()
        self.config = kwargs.pop("config", None)
        self.dummy_inputs = ...
        self.layer = ...

    def call(self, *args):
        return ...


# Initialize and compile the model as you normally would
model = MyModel()
model.compile(...)
# Build the graph by training it or passing dummy inputs
_ = model(model.dummy_inputs)
# Save model weights to local directory
model.save_pretrained("my-awesome-model")
# Push model weights to the Hub
model.push_to_hub("my-awesome-model")
# Download and initialize weights from the Hub
model = MyModel.from_pretrained("username/super-cool-model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> KerasModelHubMixin


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">class</span> <span class="hljs-title class_">MyModel</span>(tf.keras.Model, KerasModelHubMixin):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self, **kwargs</span>):
<span class="hljs-meta">... </span>        <span class="hljs-built_in">super</span>().__init__()
<span class="hljs-meta">... </span>        self.config = kwargs.pop(<span class="hljs-string">&quot;config&quot;</span>, <span class="hljs-literal">None</span>)
<span class="hljs-meta">... </span>        self.dummy_inputs = ...
<span class="hljs-meta">... </span>        self.layer = ...

<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">call</span>(<span class="hljs-params">self, *args</span>):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">return</span> ...


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initialize and compile the model as you normally would</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel()
<span class="hljs-meta">&gt;&gt;&gt; </span>model.<span class="hljs-built_in">compile</span>(...)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Build the graph by training it or passing dummy inputs</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>_ = model(model.dummy_inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save model weights to local directory</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Push model weights to the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download and initialize weights from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel.from_pretrained(<span class="hljs-string">&quot;username/super-cool-model&quot;</span>)`}}),{c(){_(p.$$.fragment)},l(u){b(p.$$.fragment,u)},m(u,f){v(p,u,f),k=!0},p:On,i(u){k||(y(p.$$.fragment,u),k=!0)},o(u){w(p.$$.fragment,u),k=!1},d(u){x(p,u)}}}function Bn(C){let p,k,u,f,M;return{c(){p=a("p"),k=s("Passing "),u=a("code"),f=s("token=True"),M=s(` is required when you want to use a private
model.`)},l(g){p=n(g,"P",{});var $=r(p);k=i($,"Passing "),u=n($,"CODE",{});var N=r(u);f=i(N,"token=True"),N.forEach(t),M=i($,` is required when you want to use a private
model.`),$.forEach(t)},m(g,$){m(g,p,$),e(p,k),e(p,u),e(u,f),e(p,M)},d(g){g&&t(p)}}}function Gn(C){let p,k,u,f,M,g,$,N,_e;return{c(){p=a("p"),k=s("Raises the following error:"),u=l(),f=a("ul"),M=a("li"),g=a("a"),$=a("em"),N=s("ValueError"),_e=s(`
if the user is not log on to the Hugging Face Hub.`),this.h()},l(E){p=n(E,"P",{});var j=r(p);k=i(j,"Raises the following error:"),j.forEach(t),u=d(E),f=n(E,"UL",{});var S=r(f);M=n(S,"LI",{});var V=r(M);g=n(V,"A",{href:!0,rel:!0});var K=r(g);$=n(K,"EM",{});var Fe=r($);N=i(Fe,"ValueError"),Fe.forEach(t),K.forEach(t),_e=i(V,`
if the user is not log on to the Hugging Face Hub.`),V.forEach(t),S.forEach(t),this.h()},h(){c(g,"href","https://docs.python.org/3/library/exceptions.html#ValueError"),c(g,"rel","nofollow")},m(E,j){m(E,p,j),e(p,k),m(E,u,j),m(E,f,j),e(f,M),e(M,g),e(g,$),e($,N),e(M,_e)},d(E){E&&t(p),E&&t(u),E&&t(f)}}}function Yn(C){let p,k,u,f,M,g,$,N,_e,E,j,S,V,K,Fe,Ze,ct,Io,Z,ht,eo,pt,gt,zo,R,ee,oo,be,mt,to,ut,Ao,H,ve,ft,B,_t,ao,bt,vt,no,yt,wt,xt,ye,$t,qe,kt,Mt,Ht,oe,we,Et,ro,jt,Tt,te,xe,Pt,so,Dt,Nt,ae,$e,St,io,It,zt,W,ke,At,lo,Lt,Ot,I,Ut,co,Ft,qt,ho,Ct,Kt,Ce,Wt,Vt,Rt,ne,Me,Bt,po,Gt,Lo,G,re,go,He,Yt,mo,Jt,Oo,z,Ee,Qt,A,Xt,Ke,Zt,ea,uo,oa,ta,fo,aa,na,ra,se,Uo,Y,ie,_o,je,sa,bo,ia,Fo,L,Te,la,Pe,da,We,ca,ha,pa,le,qo,O,De,ga,Ne,ma,vo,ua,fa,_a,de,Co,U,Se,ba,Ie,va,yo,ya,wa,xa,F,$a,wo,ka,Ma,xo,Ha,Ea,Ve,ja,Ta,Ko,J,ze,Pa,$o,Da,Wo,Q,ce,ko,Ae,Na,Mo,Sa,Vo,X,Le,Ia,Ho,za,Ro,P,Oe,Aa,Eo,La,Oa,q,Ua,jo,Fa,qa,To,Ca,Ka,Po,Wa,Va,Ra,he,Bo;return g=new Xe({}),K=new Xe({}),be=new Xe({}),ve=new D({props:{name:"class huggingface_hub.ModelHubMixin",anchor:"huggingface_hub.ModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L25"}}),we=new D({props:{name:"_save_pretrained",anchor:"huggingface_hub.ModelHubMixin._save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, pathlib.Path]"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L84"}}),xe=new D({props:{name:"_from_pretrained",anchor:"huggingface_hub.ModelHubMixin._from_pretrained",parameters:[{name:"model_id",val:": str"},{name:"revision",val:": str"},{name:"cache_dir",val:": str"},{name:"force_download",val:": bool"},{name:"proxies",val:": typing.Optional[typing.Dict]"},{name:"resume_download",val:": bool"},{name:"local_files_only",val:": bool"},{name:"token",val:": typing.Union[str, bool, NoneType]"},{name:"**model_kwargs",val:""}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L189"}}),$e=new D({props:{name:"from_pretrained",anchor:"huggingface_hub.ModelHubMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, pathlib.Path]"},{name:"force_download",val:": bool = False"},{name:"resume_download",val:": bool = False"},{name:"proxies",val:": typing.Optional[typing.Dict] = None"},{name:"token",val:": typing.Union[str, bool, NoneType] = None"},{name:"cache_dir",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"local_files_only",val:": bool = False"},{name:"revision",val:": typing.Optional[str] = None"},{name:"**model_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code>, <code>Path</code>) &#x2014;<ul>
<li>Either the <code>model_id</code> (string) of a model hosted on the Hub, e.g. <code>bigscience/bloom</code>.</li>
<li>Or a path to a <code>directory</code> containing model weights saved using
<a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.save_pretrained" rel="nofollow">save_pretrained</a>, e.g., <code>../path/to/my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Revision of the model on the Hub. Can be a branch name, a git tag or any commit id.
Defaults to the latest commit on <code>main</code> branch.`,name:"revision"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to force (re-)downloading the model weights and configuration
files from the Hub, overriding the existing cache.`,name:"force_download"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to delete incompletely received files. Will attempt to resume the
download if such a file exists.`,name:"resume_download"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on every request.`,name:"proxies"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.token",description:`<strong>token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. By default,
it will use the token cached when running <code>huggingface-cli login</code>.`,name:"token"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code>, <code>Path</code>, <em>optional</em>) &#x2014;
Path to the folder where cached files are stored.`,name:"cache_dir"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.local_files_only",description:`<strong>local_files_only</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, avoid downloading the file and return the path to the
local cached file if it exists.`,name:"local_files_only"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
Additional kwargs to pass to the model during initialization.`,name:"model_kwargs"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L90"}}),ke=new D({props:{name:"push_to_hub",anchor:"huggingface_hub.ModelHubMixin.push_to_hub",parameters:[{name:"repo_id",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"commit_message",val:": str = 'Push model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"api_endpoint",val:": typing.Optional[str] = None"},{name:"token",val:": typing.Optional[str] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
Repository name to which push.`,name:"repo_id"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Message to commit while pushing.`,name:"commit_message"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.api_endpoint",description:`<strong>api_endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files.
If not set, will use the token set when logging in with
<code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.branch",description:`<strong>branch</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <code>&quot;main&quot;</code>.`,name:"branch"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.create_pr",description:`<strong>create_pr</strong> (<code>boolean</code>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <code>branch</code> with that commit.
Defaults to <code>False</code>.`,name:"create_pr"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.allow_patterns",description:`<strong>allow_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.ignore_patterns",description:`<strong>ignore_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L208",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),Me=new D({props:{name:"save_pretrained",anchor:"huggingface_hub.ModelHubMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, pathlib.Path]"},{name:"config",val:": typing.Optional[dict] = None"},{name:"repo_id",val:": typing.Optional[str] = None"},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>Path</code>) &#x2014;
Path to directory in which the model weights and configuration will be saved.`,name:"save_directory"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Model configuration specified as a key/value dictionary.`,name:"config"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Huggingface Hub after saving it.`,name:"push_to_hub"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.repo_id",description:`<strong>repo_id</strong> (<code>str</code>, <em>optional</em>) &#x2014;
ID of your repository on the Hub. Used only if <code>push_to_hub=True</code>. Will
default to the folder name if not provided.
kwargs &#x2014;
Additional key word arguments passed along to the
<code>~utils.PushToHubMixin.push_to_hub</code> method.`,name:"repo_id"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L34"}}),He=new Xe({}),Ee=new D({props:{name:"class huggingface_hub.PyTorchModelHubMixin",anchor:"huggingface_hub.PyTorchModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L278"}}),se=new Ln({props:{anchor:"huggingface_hub.PyTorchModelHubMixin.example",$$slots:{default:[Vn]},$$scope:{ctx:C}}}),je=new Xe({}),Te=new D({props:{name:"class huggingface_hub.KerasModelHubMixin",anchor:"huggingface_hub.KerasModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L418"}}),le=new Ln({props:{anchor:"huggingface_hub.KerasModelHubMixin.example",$$slots:{default:[Rn]},$$scope:{ctx:C}}}),De=new D({props:{name:"huggingface_hub.from_pretrained_keras",anchor:"huggingface_hub.from_pretrained_keras",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.from_pretrained_keras.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:<ul>
<li>A string, the <code>model id</code> of a pretrained model hosted inside a
model repo on huggingface.co. Valid model ids can be located
at the root-level, like <code>bert-base-uncased</code>, or namespaced
under a user or organization name, like
<code>dbmdz/bert-base-german-cased</code>.</li>
<li>You can add <code>revision</code> by appending <code>@</code> at the end of model_id
simply like this: <code>dbmdz/bert-base-german-cased@main</code> Revision
is the specific model version to use. It can be a branch name,
a tag name, or a commit id, since we use a git-based system
for storing models and other artifacts on huggingface.co, so
<code>revision</code> can be any identifier allowed by git.</li>
<li>A path to a <code>directory</code> containing model weights saved using
<a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.save_pretrained" rel="nofollow">save_pretrained</a>, e.g.,
<code>./my_model_directory/</code>.</li>
<li><code>None</code> if you are both providing the configuration and state
dictionary (resp. with keyword arguments <code>config</code> and
<code>state_dict</code>).</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"huggingface_hub.from_pretrained_keras.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to force the (re-)download of the model weights and
configuration files, overriding the cached versions if they exist.`,name:"force_download"},{anchor:"huggingface_hub.from_pretrained_keras.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to delete incompletely received files. Will attempt to
resume the download if such a file exists.`,name:"resume_download"},{anchor:"huggingface_hub.from_pretrained_keras.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g.,
<code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The
proxies are used on each request.`,name:"proxies"},{anchor:"huggingface_hub.from_pretrained_keras.token",description:`<strong>token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If
<code>True</code>, will use the token generated when running <code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"huggingface_hub.from_pretrained_keras.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model
configuration should be cached if the standard cache should not be
used.`,name:"cache_dir"},{anchor:"huggingface_hub.from_pretrained_keras.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to only look at local files (i.e., do not try to download
the model).`,name:"local_files_only(bool,"},{anchor:"huggingface_hub.from_pretrained_keras.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
model_kwargs will be passed to the model during initialization`,name:"model_kwargs"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L219"}}),de=new An({props:{$$slots:{default:[Bn]},$$scope:{ctx:C}}}),Se=new D({props:{name:"huggingface_hub.push_to_hub_keras",anchor:"huggingface_hub.push_to_hub_keras",parameters:[{name:"model",val:""},{name:"repo_id",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"commit_message",val:": str = 'Push Keras model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"api_endpoint",val:": typing.Optional[str] = None"},{name:"token",val:": typing.Optional[str] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"log_dir",val:": typing.Optional[str] = None"},{name:"include_optimizer",val:": bool = False"},{name:"tags",val:": typing.Union[list, str, NoneType] = None"},{name:"plot_model",val:": bool = True"},{name:"**model_save_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.push_to_hub_keras.model",description:`<strong>model</strong> (<code>Keras.Model</code>) &#x2014;
The <a href="%60https://www.tensorflow.org/api_docs/python/tf/keras/Model%60">Keras
model</a>
you&#x2019;d like to push to the Hub. The model must be compiled and built.`,name:"model"},{anchor:"huggingface_hub.push_to_hub_keras.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
Repository name to which push`,name:"repo_id"},{anchor:"huggingface_hub.push_to_hub_keras.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;Add Keras model&#x201D;) &#x2014;
Message to commit while pushing.`,name:"commit_message"},{anchor:"huggingface_hub.push_to_hub_keras.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.push_to_hub_keras.api_endpoint",description:`<strong>api_endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.push_to_hub_keras.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If
not set, will use the token set when logging in with
<code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"huggingface_hub.push_to_hub_keras.branch",description:`<strong>branch</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <code>&quot;main&quot;</code>.`,name:"branch"},{anchor:"huggingface_hub.push_to_hub_keras.create_pr",description:`<strong>create_pr</strong> (<code>boolean</code>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <code>branch</code> with that commit.
Defaults to <code>False</code>.`,name:"create_pr"},{anchor:"huggingface_hub.push_to_hub_keras.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.push_to_hub_keras.allow_patterns",description:`<strong>allow_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.push_to_hub_keras.ignore_patterns",description:`<strong>ignore_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"},{anchor:"huggingface_hub.push_to_hub_keras.log_dir",description:`<strong>log_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;
TensorBoard logging directory to be pushed. The Hub automatically
hosts and displays a TensorBoard instance if log files are included
in the repository.`,name:"log_dir"},{anchor:"huggingface_hub.push_to_hub_keras.include_optimizer",description:`<strong>include_optimizer</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include optimizer during serialization.`,name:"include_optimizer"},{anchor:"huggingface_hub.push_to_hub_keras.tags",description:`<strong>tags</strong> (Union[<code>list</code>, <code>str</code>], <em>optional</em>) &#x2014;
List of tags that are related to model or string of a single tag. See example tags
<a href="https://github.com/huggingface/hub-docs/blame/main/modelcard.md" rel="nofollow">here</a>.`,name:"tags"},{anchor:"huggingface_hub.push_to_hub_keras.plot_model",description:`<strong>plot_model</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Setting this to <code>True</code> will plot the model and put it in the model
card. Requires graphviz and pydot to be installed.`,name:"plot_model"},{anchor:"huggingface_hub.push_to_hub_keras.model_save_kwargs(dict,",description:`<strong>model_save_kwargs(<code>dict</code>,</strong> <em>optional</em>) &#x2014;
model_save_kwargs will be passed to
<a href="https://www.tensorflow.org/api_docs/python/tf/keras/models/save_model" rel="nofollow"><code>tf.keras.models.save_model()</code></a>.`,name:"model_save_kwargs(dict,"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L278",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),ze=new D({props:{name:"huggingface_hub.save_pretrained_keras",anchor:"huggingface_hub.save_pretrained_keras",parameters:[{name:"model",val:""},{name:"save_directory",val:": typing.Union[str, pathlib.Path]"},{name:"config",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"include_optimizer",val:": bool = False"},{name:"plot_model",val:": bool = True"},{name:"tags",val:": typing.Union[list, str, NoneType] = None"},{name:"**model_save_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.save_pretrained_keras.model",description:`<strong>model</strong> (<code>Keras.Model</code>) &#x2014;
The <a href="https://www.tensorflow.org/api_docs/python/tf/keras/Model" rel="nofollow">Keras
model</a>
you&#x2019;d like to save. The model must be compiled and built.`,name:"model"},{anchor:"huggingface_hub.save_pretrained_keras.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>Path</code>) &#x2014;
Specify directory in which you want to save the Keras model.`,name:"save_directory"},{anchor:"huggingface_hub.save_pretrained_keras.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.save_pretrained_keras.include_optimizer(bool,",description:`<strong>include_optimizer(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include optimizer in serialization.`,name:"include_optimizer(bool,"},{anchor:"huggingface_hub.save_pretrained_keras.plot_model",description:`<strong>plot_model</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Setting this to <code>True</code> will plot the model and put it in the model
card. Requires graphviz and pydot to be installed.`,name:"plot_model"},{anchor:"huggingface_hub.save_pretrained_keras.tags",description:`<strong>tags</strong> (Union[<code>str</code>,<code>list</code>], <em>optional</em>) &#x2014;
List of tags that are related to model or string of a single tag. See example tags
<a href="https://github.com/huggingface/hub-docs/blame/main/modelcard.md" rel="nofollow">here</a>.`,name:"tags"},{anchor:"huggingface_hub.save_pretrained_keras.model_save_kwargs(dict,",description:`<strong>model_save_kwargs(<code>dict</code>,</strong> <em>optional</em>) &#x2014;
model_save_kwargs will be passed to
<a href="https://www.tensorflow.org/api_docs/python/tf/keras/models/save_model" rel="nofollow"><code>tf.keras.models.save_model()</code></a>.`,name:"model_save_kwargs(dict,"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L134"}}),Ae=new Xe({}),Le=new D({props:{name:"huggingface_hub.from_pretrained_fastai",anchor:"huggingface_hub.from_pretrained_fastai",parameters:[{name:"repo_id",val:": str"},{name:"revision",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"huggingface_hub.from_pretrained_fastai.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
The location where the pickled fastai.Learner is. It can be either of the two:<ul>
<li>Hosted on the Hugging Face Hub. E.g.: &#x2018;espejelomar/fatai-pet-breeds-classification&#x2019; or &#x2018;distilgpt2&#x2019;.
You can add a <code>revision</code> by appending <code>@</code> at the end of <code>repo_id</code>. E.g.: <code>dbmdz/bert-base-german-cased@main</code>.
Revision is the specific model version to use. Since we use a git-based system for storing models and other
artifacts on the Hugging Face Hub, it can be a branch name, a tag name, or a commit id.</li>
<li>Hosted locally. <code>repo_id</code> would be a directory containing the pickle and a pyproject.toml
indicating the fastai and fastcore versions used to build the <code>fastai.Learner</code>. E.g.: <code>./my_model_directory/</code>.</li>
</ul>`,name:"repo_id"},{anchor:"huggingface_hub.from_pretrained_fastai.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Revision at which the repo&#x2019;s files are downloaded. See documentation of <code>snapshot_download</code>.`,name:"revision"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/fastai_utils.py#L298",returnDescription:`
<p>The <code>fastai.Learner</code> model in the <code>repo_id</code> repo.</p>
`}}),Oe=new D({props:{name:"huggingface_hub.push_to_hub_fastai",anchor:"huggingface_hub.push_to_hub_fastai",parameters:[{name:"learner",val:""},{name:"repo_id",val:": str"},{name:"commit_message",val:": str = 'Push FastAI model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"token",val:": typing.Optional[str] = None"},{name:"config",val:": typing.Optional[dict] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"api_endpoint",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"huggingface_hub.push_to_hub_fastai.learner",description:`<strong>learner</strong> (<em>Learner</em>) &#x2014;
The *fastai.Learner&#x2019; you&#x2019;d like to push to the Hub.`,name:"learner"},{anchor:"huggingface_hub.push_to_hub_fastai.repo_id",description:`<strong>repo_id</strong> (<em>str</em>) &#x2014;
The repository id for your model in Hub in the format of &#x201C;namespace/repo_name&#x201D;. The namespace can be your individual account or an organization to which you have write access (for example, &#x2018;stanfordnlp/stanza-de&#x2019;).`,name:"repo_id"},{anchor:"huggingface_hub.push_to_hub_fastai.commit_message",description:"<strong>commit_message</strong> (<em>str`, </em>optional*) &#x2014; Message to commit while pushing. Will default to <code>&quot;add model&quot;</code>.",name:"commit_message"},{anchor:"huggingface_hub.push_to_hub_fastai.private",description:`<strong>private</strong> (<em>bool</em>, <em>optional</em>, defaults to <em>False</em>) &#x2014;
Whether or not the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.push_to_hub_fastai.token",description:`<strong>token</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The Hugging Face account token to use as HTTP bearer authorization for remote files. If <code>None</code>, the token will be asked by a prompt.`,name:"token"},{anchor:"huggingface_hub.push_to_hub_fastai.config",description:`<strong>config</strong> (<em>dict</em>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.push_to_hub_fastai.branch",description:`<strong>branch</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <em>&#x201C;main&#x201D;</em>.`,name:"branch"},{anchor:"huggingface_hub.push_to_hub_fastai.create_pr",description:`<strong>create_pr</strong> (<em>boolean</em>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <em>branch</em> with that commit.
Defaults to <em>False</em>.`,name:"create_pr"},{anchor:"huggingface_hub.push_to_hub_fastai.api_endpoint",description:`<strong>api_endpoint</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.push_to_hub_fastai.allow_patterns",description:`<strong>allow_patterns</strong> (<em>List[str]</em> or <em>str</em>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.push_to_hub_fastai.ignore_patterns",description:`<strong>ignore_patterns</strong> (<em>List[str]</em> or <em>str</em>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/fastai_utils.py#L343",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),he=new An({props:{$$slots:{default:[Gn]},$$scope:{ctx:C}}}),{c(){p=a("meta"),k=l(),u=a("h1"),f=a("a"),M=a("span"),_(g.$$.fragment),$=l(),N=a("span"),_e=s("Mixins & serialization methods"),E=l(),j=a("h2"),S=a("a"),V=a("span"),_(K.$$.fragment),Fe=l(),Ze=a("span"),ct=s("Mixins"),Io=l(),Z=a("p"),ht=s("The "),eo=a("code"),pt=s("huggingface_hub"),gt=s(` library offers a range of mixins that can be used as a parent class for your
objects, in order to provide simple uploading and downloading functions.`),zo=l(),R=a("h3"),ee=a("a"),oo=a("span"),_(be.$$.fragment),mt=l(),to=a("span"),ut=s("Generic"),Ao=l(),H=a("div"),_(ve.$$.fragment),ft=l(),B=a("p"),_t=s(`A generic Hub mixin for machine learning models. Define your own mixin for any framework
by inheriting from this class and overwriting the `),ao=a("code"),bt=s("_from_pretrained"),vt=s(" and "),no=a("code"),yt=s("_save_pretrained"),wt=s(`
methods to define custom logic for saving and loading your classes.`),xt=l(),ye=a("p"),$t=s("See "),qe=a("a"),kt=s("PyTorchModelHubMixin"),Mt=s(" for an example."),Ht=l(),oe=a("div"),_(we.$$.fragment),Et=l(),ro=a("p"),jt=s("Overwrite this method in subclass to define how to save your model."),Tt=l(),te=a("div"),_(xe.$$.fragment),Pt=l(),so=a("p"),Dt=s(`Overwrite this method in subclass to define how to load your model from
pretrained`),Nt=l(),ae=a("div"),_($e.$$.fragment),St=l(),io=a("p"),It=s("Download a model from the Huggingface Hub and instantiate it."),zt=l(),W=a("div"),_(ke.$$.fragment),At=l(),lo=a("p"),Lt=s("Upload model checkpoint to the Hub."),Ot=l(),I=a("p"),Ut=s("Use "),co=a("code"),Ft=s("allow_patterns"),qt=s(" and "),ho=a("code"),Ct=s("ignore_patterns"),Kt=s(` to precisely filter which files
should be pushed to the hub. See `),Ce=a("a"),Wt=s("upload_folder()"),Vt=s(" reference for more details."),Rt=l(),ne=a("div"),_(Me.$$.fragment),Bt=l(),po=a("p"),Gt=s("Save weights in local directory."),Lo=l(),G=a("h3"),re=a("a"),go=a("span"),_(He.$$.fragment),Yt=l(),mo=a("span"),Jt=s("PyTorch"),Oo=l(),z=a("div"),_(Ee.$$.fragment),Qt=l(),A=a("p"),Xt=s("Implementation of "),Ke=a("a"),Zt=s("ModelHubMixin"),ea=s(` to provide model Hub upload/download
capabilities to PyTorch models. The model is set in evaluation mode by
default using `),uo=a("code"),oa=s("model.eval()"),ta=s(` (dropout modules are deactivated). To train
the model, you should first set it back in training mode with
`),fo=a("code"),aa=s("model.train()"),na=s("."),ra=l(),_(se.$$.fragment),Uo=l(),Y=a("h3"),ie=a("a"),_o=a("span"),_(je.$$.fragment),sa=l(),bo=a("span"),ia=s("Keras"),Fo=l(),L=a("div"),_(Te.$$.fragment),la=l(),Pe=a("p"),da=s("Implementation of "),We=a("a"),ca=s("ModelHubMixin"),ha=s(` to provide model Hub upload/download
capabilities to Keras models.`),pa=l(),_(le.$$.fragment),qo=l(),O=a("div"),_(De.$$.fragment),ga=l(),Ne=a("p"),ma=s(`Instantiate a pretrained Keras model from a pre-trained model from the Hub.
The model is expected to be in `),vo=a("code"),ua=s("SavedModel"),fa=s(" format."),_a=l(),_(de.$$.fragment),Co=l(),U=a("div"),_(Se.$$.fragment),ba=l(),Ie=a("p"),va=s(`Upload model checkpoint or tokenizer files to the Hub while synchronizing a
local clone of the repo in `),yo=a("code"),ya=s("repo_path_or_name"),wa=s("."),xa=l(),F=a("p"),$a=s("Use "),wo=a("code"),ka=s("allow_patterns"),Ma=s(" and "),xo=a("code"),Ha=s("ignore_patterns"),Ea=s(` to precisely filter which files should be
pushed to the hub. See `),Ve=a("a"),ja=s("upload_folder()"),Ta=s(" reference for more details."),Ko=l(),J=a("div"),_(ze.$$.fragment),Pa=l(),$o=a("p"),Da=s(`Saves a Keras model to save_directory in SavedModel format. Use this if
you\u2019re using the Functional or Sequential APIs.`),Wo=l(),Q=a("h3"),ce=a("a"),ko=a("span"),_(Ae.$$.fragment),Na=l(),Mo=a("span"),Sa=s("Fastai"),Vo=l(),X=a("div"),_(Le.$$.fragment),Ia=l(),Ho=a("p"),za=s("Load pretrained fastai model from the Hub or from a local directory."),Ro=l(),P=a("div"),_(Oe.$$.fragment),Aa=l(),Eo=a("p"),La=s("Upload learner checkpoint files to the Hub."),Oa=l(),q=a("p"),Ua=s("Use "),jo=a("em"),Fa=s("allow_patterns"),qa=s(" and "),To=a("em"),Ca=s("ignore_patterns"),Ka=s(` to precisely filter which files should be
pushed to the hub. See [`),Po=a("em"),Wa=s("upload_folder"),Va=s("] reference for more details."),Ra=l(),_(he.$$.fragment),this.h()},l(o){const h=Kn('[data-svelte="svelte-1phssyn"]',document.head);p=n(h,"META",{name:!0,content:!0}),h.forEach(t),k=d(o),u=n(o,"H1",{class:!0});var Ue=r(u);f=n(Ue,"A",{id:!0,class:!0,href:!0});var Do=r(f);M=n(Do,"SPAN",{});var No=r(M);b(g.$$.fragment,No),No.forEach(t),Do.forEach(t),$=d(Ue),N=n(Ue,"SPAN",{});var So=r(N);_e=i(So,"Mixins & serialization methods"),So.forEach(t),Ue.forEach(t),E=d(o),j=n(o,"H2",{class:!0});var Go=r(j);S=n(Go,"A",{id:!0,class:!0,href:!0});var Ba=r(S);V=n(Ba,"SPAN",{});var Ga=r(V);b(K.$$.fragment,Ga),Ga.forEach(t),Ba.forEach(t),Fe=d(Go),Ze=n(Go,"SPAN",{});var Ya=r(Ze);ct=i(Ya,"Mixins"),Ya.forEach(t),Go.forEach(t),Io=d(o),Z=n(o,"P",{});var Yo=r(Z);ht=i(Yo,"The "),eo=n(Yo,"CODE",{});var Ja=r(eo);pt=i(Ja,"huggingface_hub"),Ja.forEach(t),gt=i(Yo,` library offers a range of mixins that can be used as a parent class for your
objects, in order to provide simple uploading and downloading functions.`),Yo.forEach(t),zo=d(o),R=n(o,"H3",{class:!0});var Jo=r(R);ee=n(Jo,"A",{id:!0,class:!0,href:!0});var Qa=r(ee);oo=n(Qa,"SPAN",{});var Xa=r(oo);b(be.$$.fragment,Xa),Xa.forEach(t),Qa.forEach(t),mt=d(Jo),to=n(Jo,"SPAN",{});var Za=r(to);ut=i(Za,"Generic"),Za.forEach(t),Jo.forEach(t),Ao=d(o),H=n(o,"DIV",{class:!0});var T=r(H);b(ve.$$.fragment,T),ft=d(T),B=n(T,"P",{});var Re=r(B);_t=i(Re,`A generic Hub mixin for machine learning models. Define your own mixin for any framework
by inheriting from this class and overwriting the `),ao=n(Re,"CODE",{});var en=r(ao);bt=i(en,"_from_pretrained"),en.forEach(t),vt=i(Re," and "),no=n(Re,"CODE",{});var on=r(no);yt=i(on,"_save_pretrained"),on.forEach(t),wt=i(Re,`
methods to define custom logic for saving and loading your classes.`),Re.forEach(t),xt=d(T),ye=n(T,"P",{});var Qo=r(ye);$t=i(Qo,"See "),qe=n(Qo,"A",{href:!0});var tn=r(qe);kt=i(tn,"PyTorchModelHubMixin"),tn.forEach(t),Mt=i(Qo," for an example."),Qo.forEach(t),Ht=d(T),oe=n(T,"DIV",{class:!0});var Xo=r(oe);b(we.$$.fragment,Xo),Et=d(Xo),ro=n(Xo,"P",{});var an=r(ro);jt=i(an,"Overwrite this method in subclass to define how to save your model."),an.forEach(t),Xo.forEach(t),Tt=d(T),te=n(T,"DIV",{class:!0});var Zo=r(te);b(xe.$$.fragment,Zo),Pt=d(Zo),so=n(Zo,"P",{});var nn=r(so);Dt=i(nn,`Overwrite this method in subclass to define how to load your model from
pretrained`),nn.forEach(t),Zo.forEach(t),Nt=d(T),ae=n(T,"DIV",{class:!0});var et=r(ae);b($e.$$.fragment,et),St=d(et),io=n(et,"P",{});var rn=r(io);It=i(rn,"Download a model from the Huggingface Hub and instantiate it."),rn.forEach(t),et.forEach(t),zt=d(T),W=n(T,"DIV",{class:!0});var Be=r(W);b(ke.$$.fragment,Be),At=d(Be),lo=n(Be,"P",{});var sn=r(lo);Lt=i(sn,"Upload model checkpoint to the Hub."),sn.forEach(t),Ot=d(Be),I=n(Be,"P",{});var pe=r(I);Ut=i(pe,"Use "),co=n(pe,"CODE",{});var ln=r(co);Ft=i(ln,"allow_patterns"),ln.forEach(t),qt=i(pe," and "),ho=n(pe,"CODE",{});var dn=r(ho);Ct=i(dn,"ignore_patterns"),dn.forEach(t),Kt=i(pe,` to precisely filter which files
should be pushed to the hub. See `),Ce=n(pe,"A",{href:!0});var cn=r(Ce);Wt=i(cn,"upload_folder()"),cn.forEach(t),Vt=i(pe," reference for more details."),pe.forEach(t),Be.forEach(t),Rt=d(T),ne=n(T,"DIV",{class:!0});var ot=r(ne);b(Me.$$.fragment,ot),Bt=d(ot),po=n(ot,"P",{});var hn=r(po);Gt=i(hn,"Save weights in local directory."),hn.forEach(t),ot.forEach(t),T.forEach(t),Lo=d(o),G=n(o,"H3",{class:!0});var tt=r(G);re=n(tt,"A",{id:!0,class:!0,href:!0});var pn=r(re);go=n(pn,"SPAN",{});var gn=r(go);b(He.$$.fragment,gn),gn.forEach(t),pn.forEach(t),Yt=d(tt),mo=n(tt,"SPAN",{});var mn=r(mo);Jt=i(mn,"PyTorch"),mn.forEach(t),tt.forEach(t),Oo=d(o),z=n(o,"DIV",{class:!0});var Ge=r(z);b(Ee.$$.fragment,Ge),Qt=d(Ge),A=n(Ge,"P",{});var ge=r(A);Xt=i(ge,"Implementation of "),Ke=n(ge,"A",{href:!0});var un=r(Ke);Zt=i(un,"ModelHubMixin"),un.forEach(t),ea=i(ge,` to provide model Hub upload/download
capabilities to PyTorch models. The model is set in evaluation mode by
default using `),uo=n(ge,"CODE",{});var fn=r(uo);oa=i(fn,"model.eval()"),fn.forEach(t),ta=i(ge,` (dropout modules are deactivated). To train
the model, you should first set it back in training mode with
`),fo=n(ge,"CODE",{});var _n=r(fo);aa=i(_n,"model.train()"),_n.forEach(t),na=i(ge,"."),ge.forEach(t),ra=d(Ge),b(se.$$.fragment,Ge),Ge.forEach(t),Uo=d(o),Y=n(o,"H3",{class:!0});var at=r(Y);ie=n(at,"A",{id:!0,class:!0,href:!0});var bn=r(ie);_o=n(bn,"SPAN",{});var vn=r(_o);b(je.$$.fragment,vn),vn.forEach(t),bn.forEach(t),sa=d(at),bo=n(at,"SPAN",{});var yn=r(bo);ia=i(yn,"Keras"),yn.forEach(t),at.forEach(t),Fo=d(o),L=n(o,"DIV",{class:!0});var Ye=r(L);b(Te.$$.fragment,Ye),la=d(Ye),Pe=n(Ye,"P",{});var nt=r(Pe);da=i(nt,"Implementation of "),We=n(nt,"A",{href:!0});var wn=r(We);ca=i(wn,"ModelHubMixin"),wn.forEach(t),ha=i(nt,` to provide model Hub upload/download
capabilities to Keras models.`),nt.forEach(t),pa=d(Ye),b(le.$$.fragment,Ye),Ye.forEach(t),qo=d(o),O=n(o,"DIV",{class:!0});var Je=r(O);b(De.$$.fragment,Je),ga=d(Je),Ne=n(Je,"P",{});var rt=r(Ne);ma=i(rt,`Instantiate a pretrained Keras model from a pre-trained model from the Hub.
The model is expected to be in `),vo=n(rt,"CODE",{});var xn=r(vo);ua=i(xn,"SavedModel"),xn.forEach(t),fa=i(rt," format."),rt.forEach(t),_a=d(Je),b(de.$$.fragment,Je),Je.forEach(t),Co=d(o),U=n(o,"DIV",{class:!0});var Qe=r(U);b(Se.$$.fragment,Qe),ba=d(Qe),Ie=n(Qe,"P",{});var st=r(Ie);va=i(st,`Upload model checkpoint or tokenizer files to the Hub while synchronizing a
local clone of the repo in `),yo=n(st,"CODE",{});var $n=r(yo);ya=i($n,"repo_path_or_name"),$n.forEach(t),wa=i(st,"."),st.forEach(t),xa=d(Qe),F=n(Qe,"P",{});var me=r(F);$a=i(me,"Use "),wo=n(me,"CODE",{});var kn=r(wo);ka=i(kn,"allow_patterns"),kn.forEach(t),Ma=i(me," and "),xo=n(me,"CODE",{});var Mn=r(xo);Ha=i(Mn,"ignore_patterns"),Mn.forEach(t),Ea=i(me,` to precisely filter which files should be
pushed to the hub. See `),Ve=n(me,"A",{href:!0});var Hn=r(Ve);ja=i(Hn,"upload_folder()"),Hn.forEach(t),Ta=i(me," reference for more details."),me.forEach(t),Qe.forEach(t),Ko=d(o),J=n(o,"DIV",{class:!0});var it=r(J);b(ze.$$.fragment,it),Pa=d(it),$o=n(it,"P",{});var En=r($o);Da=i(En,`Saves a Keras model to save_directory in SavedModel format. Use this if
you\u2019re using the Functional or Sequential APIs.`),En.forEach(t),it.forEach(t),Wo=d(o),Q=n(o,"H3",{class:!0});var lt=r(Q);ce=n(lt,"A",{id:!0,class:!0,href:!0});var jn=r(ce);ko=n(jn,"SPAN",{});var Tn=r(ko);b(Ae.$$.fragment,Tn),Tn.forEach(t),jn.forEach(t),Na=d(lt),Mo=n(lt,"SPAN",{});var Pn=r(Mo);Sa=i(Pn,"Fastai"),Pn.forEach(t),lt.forEach(t),Vo=d(o),X=n(o,"DIV",{class:!0});var dt=r(X);b(Le.$$.fragment,dt),Ia=d(dt),Ho=n(dt,"P",{});var Dn=r(Ho);za=i(Dn,"Load pretrained fastai model from the Hub or from a local directory."),Dn.forEach(t),dt.forEach(t),Ro=d(o),P=n(o,"DIV",{class:!0});var ue=r(P);b(Oe.$$.fragment,ue),Aa=d(ue),Eo=n(ue,"P",{});var Nn=r(Eo);La=i(Nn,"Upload learner checkpoint files to the Hub."),Nn.forEach(t),Oa=d(ue),q=n(ue,"P",{});var fe=r(q);Ua=i(fe,"Use "),jo=n(fe,"EM",{});var Sn=r(jo);Fa=i(Sn,"allow_patterns"),Sn.forEach(t),qa=i(fe," and "),To=n(fe,"EM",{});var In=r(To);Ca=i(In,"ignore_patterns"),In.forEach(t),Ka=i(fe,` to precisely filter which files should be
pushed to the hub. See [`),Po=n(fe,"EM",{});var zn=r(Po);Wa=i(zn,"upload_folder"),zn.forEach(t),Va=i(fe,"] reference for more details."),fe.forEach(t),Ra=d(ue),b(he.$$.fragment,ue),ue.forEach(t),this.h()},h(){c(p,"name","hf:doc:metadata"),c(p,"content",JSON.stringify(Jn)),c(f,"id","mixins-serialization-methods"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#mixins-serialization-methods"),c(u,"class","relative group"),c(S,"id","mixins"),c(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(S,"href","#mixins"),c(j,"class","relative group"),c(ee,"id","huggingface_hub.ModelHubMixin"),c(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ee,"href","#huggingface_hub.ModelHubMixin"),c(R,"class","relative group"),c(qe,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.PyTorchModelHubMixin"),c(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ce,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.upload_folder"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(re,"id","huggingface_hub.PyTorchModelHubMixin"),c(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(re,"href","#huggingface_hub.PyTorchModelHubMixin"),c(G,"class","relative group"),c(Ke,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin"),c(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ie,"id","huggingface_hub.KerasModelHubMixin"),c(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ie,"href","#huggingface_hub.KerasModelHubMixin"),c(Y,"class","relative group"),c(We,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin"),c(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ve,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.upload_folder"),c(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ce,"id","huggingface_hub.from_pretrained_fastai"),c(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ce,"href","#huggingface_hub.from_pretrained_fastai"),c(Q,"class","relative group"),c(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,h){e(document.head,p),m(o,k,h),m(o,u,h),e(u,f),e(f,M),v(g,M,null),e(u,$),e(u,N),e(N,_e),m(o,E,h),m(o,j,h),e(j,S),e(S,V),v(K,V,null),e(j,Fe),e(j,Ze),e(Ze,ct),m(o,Io,h),m(o,Z,h),e(Z,ht),e(Z,eo),e(eo,pt),e(Z,gt),m(o,zo,h),m(o,R,h),e(R,ee),e(ee,oo),v(be,oo,null),e(R,mt),e(R,to),e(to,ut),m(o,Ao,h),m(o,H,h),v(ve,H,null),e(H,ft),e(H,B),e(B,_t),e(B,ao),e(ao,bt),e(B,vt),e(B,no),e(no,yt),e(B,wt),e(H,xt),e(H,ye),e(ye,$t),e(ye,qe),e(qe,kt),e(ye,Mt),e(H,Ht),e(H,oe),v(we,oe,null),e(oe,Et),e(oe,ro),e(ro,jt),e(H,Tt),e(H,te),v(xe,te,null),e(te,Pt),e(te,so),e(so,Dt),e(H,Nt),e(H,ae),v($e,ae,null),e(ae,St),e(ae,io),e(io,It),e(H,zt),e(H,W),v(ke,W,null),e(W,At),e(W,lo),e(lo,Lt),e(W,Ot),e(W,I),e(I,Ut),e(I,co),e(co,Ft),e(I,qt),e(I,ho),e(ho,Ct),e(I,Kt),e(I,Ce),e(Ce,Wt),e(I,Vt),e(H,Rt),e(H,ne),v(Me,ne,null),e(ne,Bt),e(ne,po),e(po,Gt),m(o,Lo,h),m(o,G,h),e(G,re),e(re,go),v(He,go,null),e(G,Yt),e(G,mo),e(mo,Jt),m(o,Oo,h),m(o,z,h),v(Ee,z,null),e(z,Qt),e(z,A),e(A,Xt),e(A,Ke),e(Ke,Zt),e(A,ea),e(A,uo),e(uo,oa),e(A,ta),e(A,fo),e(fo,aa),e(A,na),e(z,ra),v(se,z,null),m(o,Uo,h),m(o,Y,h),e(Y,ie),e(ie,_o),v(je,_o,null),e(Y,sa),e(Y,bo),e(bo,ia),m(o,Fo,h),m(o,L,h),v(Te,L,null),e(L,la),e(L,Pe),e(Pe,da),e(Pe,We),e(We,ca),e(Pe,ha),e(L,pa),v(le,L,null),m(o,qo,h),m(o,O,h),v(De,O,null),e(O,ga),e(O,Ne),e(Ne,ma),e(Ne,vo),e(vo,ua),e(Ne,fa),e(O,_a),v(de,O,null),m(o,Co,h),m(o,U,h),v(Se,U,null),e(U,ba),e(U,Ie),e(Ie,va),e(Ie,yo),e(yo,ya),e(Ie,wa),e(U,xa),e(U,F),e(F,$a),e(F,wo),e(wo,ka),e(F,Ma),e(F,xo),e(xo,Ha),e(F,Ea),e(F,Ve),e(Ve,ja),e(F,Ta),m(o,Ko,h),m(o,J,h),v(ze,J,null),e(J,Pa),e(J,$o),e($o,Da),m(o,Wo,h),m(o,Q,h),e(Q,ce),e(ce,ko),v(Ae,ko,null),e(Q,Na),e(Q,Mo),e(Mo,Sa),m(o,Vo,h),m(o,X,h),v(Le,X,null),e(X,Ia),e(X,Ho),e(Ho,za),m(o,Ro,h),m(o,P,h),v(Oe,P,null),e(P,Aa),e(P,Eo),e(Eo,La),e(P,Oa),e(P,q),e(q,Ua),e(q,jo),e(jo,Fa),e(q,qa),e(q,To),e(To,Ca),e(q,Ka),e(q,Po),e(Po,Wa),e(q,Va),e(P,Ra),v(he,P,null),Bo=!0},p(o,[h]){const Ue={};h&2&&(Ue.$$scope={dirty:h,ctx:o}),se.$set(Ue);const Do={};h&2&&(Do.$$scope={dirty:h,ctx:o}),le.$set(Do);const No={};h&2&&(No.$$scope={dirty:h,ctx:o}),de.$set(No);const So={};h&2&&(So.$$scope={dirty:h,ctx:o}),he.$set(So)},i(o){Bo||(y(g.$$.fragment,o),y(K.$$.fragment,o),y(be.$$.fragment,o),y(ve.$$.fragment,o),y(we.$$.fragment,o),y(xe.$$.fragment,o),y($e.$$.fragment,o),y(ke.$$.fragment,o),y(Me.$$.fragment,o),y(He.$$.fragment,o),y(Ee.$$.fragment,o),y(se.$$.fragment,o),y(je.$$.fragment,o),y(Te.$$.fragment,o),y(le.$$.fragment,o),y(De.$$.fragment,o),y(de.$$.fragment,o),y(Se.$$.fragment,o),y(ze.$$.fragment,o),y(Ae.$$.fragment,o),y(Le.$$.fragment,o),y(Oe.$$.fragment,o),y(he.$$.fragment,o),Bo=!0)},o(o){w(g.$$.fragment,o),w(K.$$.fragment,o),w(be.$$.fragment,o),w(ve.$$.fragment,o),w(we.$$.fragment,o),w(xe.$$.fragment,o),w($e.$$.fragment,o),w(ke.$$.fragment,o),w(Me.$$.fragment,o),w(He.$$.fragment,o),w(Ee.$$.fragment,o),w(se.$$.fragment,o),w(je.$$.fragment,o),w(Te.$$.fragment,o),w(le.$$.fragment,o),w(De.$$.fragment,o),w(de.$$.fragment,o),w(Se.$$.fragment,o),w(ze.$$.fragment,o),w(Ae.$$.fragment,o),w(Le.$$.fragment,o),w(Oe.$$.fragment,o),w(he.$$.fragment,o),Bo=!1},d(o){t(p),o&&t(k),o&&t(u),x(g),o&&t(E),o&&t(j),x(K),o&&t(Io),o&&t(Z),o&&t(zo),o&&t(R),x(be),o&&t(Ao),o&&t(H),x(ve),x(we),x(xe),x($e),x(ke),x(Me),o&&t(Lo),o&&t(G),x(He),o&&t(Oo),o&&t(z),x(Ee),x(se),o&&t(Uo),o&&t(Y),x(je),o&&t(Fo),o&&t(L),x(Te),x(le),o&&t(qo),o&&t(O),x(De),x(de),o&&t(Co),o&&t(U),x(Se),o&&t(Ko),o&&t(J),x(ze),o&&t(Wo),o&&t(Q),x(Ae),o&&t(Vo),o&&t(X),x(Le),o&&t(Ro),o&&t(P),x(Oe),x(he)}}}const Jn={local:"mixins-serialization-methods",sections:[{local:"mixins",sections:[{local:"huggingface_hub.ModelHubMixin",title:"Generic"},{local:"huggingface_hub.PyTorchModelHubMixin",title:"PyTorch"},{local:"huggingface_hub.KerasModelHubMixin",title:"Keras"},{local:"huggingface_hub.from_pretrained_fastai",title:"Fastai"}],title:"Mixins"}],title:"Mixins & serialization methods"};function Qn(C){return Wn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class nr extends Fn{constructor(p){super();qn(this,p,Qn,Yn,Cn,{})}}export{nr as default,Jn as metadata};
